package Vyroba_kapacity;

my $pkg="Vyroba_kapacity";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use Info;
use Spolecnost;

#==== Globalni promena tohohle balicku
my %T2dm=(
   "tAmin" => "11",
   "tVmin" => "11",
   "tBmin" => "15"
);


#==== Napojeni na DB
my $dbh=My->dbh;



#========= Cast Plan 1 ==================================================#

#-- Souhrn --

#- Vypocet kolik je treba casu a stroju (respektive lidi) (klic: str,prac,obdobi,"")
sub KAPsouhrn_plan {
   my ($pkg_p, $polozky)=@_;
   my $KAPmin;
   # vypocet kolik je treba vyrobit kusu dle planu (klic: zak,kmint,obdobi)
   my $KAPks=$pkg->kapks_plan($polozky);
   # pamatovak momentalnich promennych prostredi (abych je mohl posleze vratit)
   my $Eorg=get_env("org");
   my $Edatum=get_env("datum");
   foreach my $zak (keys %{$KAPks}) {
      foreach my $kmint (keys %{$$KAPks{$zak}}) {
         foreach my $obdobi (keys %{$$KAPks{$zak}{$kmint}}) {
            # nastaveni promennych prostredi pro ucely moznosti uzit fci zjistujici normativy a dalsi udaje v normach i jinde
            set_env("org",$$KAPks{$zak}{$kmint}{$obdobi}{org});
            # poznamka - doplnujici udaje budu ziskavat na datum platnosti zjisteneho terminu (pokud jde vsak o minulost tak na aktualni datum)
            if($$KAPks{$zak}{$kmint}{$obdobi}{normplat} ge My->date_now) {
               set_env("datum",$$KAPks{$zak}{$kmint}{$obdobi}{normplat});
            }
            else {
               set_env("datum", My->date_now);
            }
            # zjisteni informaci o fondu pracovni doby - u org pro kterou pocitam kapacity
            my $kapfond=Info->kapfond($Eorg,$$polozky{vpdruhobd}{value});
            # vypocet casu na jeden ks
            my $KAPmin1ks;
            if($Eorg eq get_env("org")) {
               $KAPmin1ks=$pkg->KAPsouhrn_plan_min1ks($zak,$kmint);
            }
            else {
               $KAPmin1ks=$pkg->KAPsouhrn_plan_min1ks_koop($zak,$kmint,$Eorg);
            }
            foreach my $str (keys %{$KAPmin1ks}) {
               foreach my $prac (keys %{$$KAPmin1ks{$str}}) {
                  my $skupprac;
                  if(!$$polozky{skupprac}{value}) {
                     $skupprac=$prac;
                  }
                  else {
                     my $info_prac=Info->prac($str,$prac);
                     $skupprac=$$info_prac{skup};
                  }
                  if($$KAPmin1ks{$str}{$prac}{tAmin}>0 or $$KAPmin1ks{$str}{$prac}{tVmin}>0 or $$KAPmin1ks{$str}{$prac}{tBmin}>0) {
                     if($$polozky{rezim}{value} eq "0") {
                        my $info_kapprac=Info->kapprac($str,$prac);
                        foreach my $tXmin ("tVmin","tBmin") {
                           my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$str}{$prac}{$tXmin}/60;
                           $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                           if($kapfond!=0) {
                              $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond/$$info_kapprac{smeny};
                           }
                        }
                     }
                     elsif($$polozky{rezim}{value} eq "1") {
                        foreach my $tXmin ("tVmin","tBmin") {
                           my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$str}{$prac}{$tXmin}/60;
                           $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                           if($kapfond!=0) {
                              $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond;
                           }
                        }
                     }
                     elsif($$polozky{rezim}{value} eq "2") {
                        my $info_kapprac=Info->kapprac($str,$prac);
                        foreach my $tXmin ("tAmin","tBmin") {
                           my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$str}{$prac}{$tXmin}/60/$$info_kapprac{vykon};
                           $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                           if($kapfond!=0) {
                              $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond;
                           }
                        }
                     }
                     elsif($$polozky{rezim}{value} eq "3") {
                        foreach my $tXmin ("tAmin","tBmin") {
                           my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$str}{$prac}{$tXmin}/60;
                           $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                           if($kapfond!=0) {
                              $$KAPmin{$str}{$skupprac}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond;
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }
   # vraceni promennych prostredi do puvodniho stavu
   set_env("org",$Eorg);
   set_env("datum",$Edatum);
   return $KAPmin;
}

#- Funkce pocita tAmin, tVmin a tBmin na jeden kus zak na prislusnem kmint
sub KAPsouhrn_plan_min1ks {
   my ($pkg_p, $zak,$kmint,$normativkoop)=@_;
   my $KAPmin1ks;
   my $normativ;
   if(!defined($normativkoop)) {
      $normativ=Info->normativy($zak,$kmint);
   }
   else {
      $normativ=$normativkoop;
   }
   # Napocitani udaju z vykonove normy
   my $sth=$dbh->prepare(q{
      select
         Vykon_norma.oper,
         Vykon_norma.str,
         Vykon_norma.prac,
         Vykon_norma.tamin,
         Vykon_norma.tbmin/Vykon_norma.davka as tbmin1ks,
         Vykon_norma.tvmin
      from
         Vyroba_priprava.Vykon_norma
      where
         Vykon_norma.org=? and
         Vykon_norma.zak=? and
         Vykon_norma.oper>=? and
         Vykon_norma.oper<=? and
         Vykon_norma.platod<=? and
         Vykon_norma.platdo>=? and
         Vykon_norma.ind!="5"
      order by
         Vykon_norma.oper asc
   });
   $sth->execute(get_env("org"),$zak,$$normativ{odoper},$$normativ{dooper},get_env("datum"),get_env("datum"));
   my $KAPmin1ksoper;
   while(my $ref=$sth->fetchrow_hashref) {
      $$KAPmin1ksoper{$$ref{oper}}=$ref;
   }
   $sth->finish;
   # Vyrazeni operaci, ktere se delaji v kooperaci na jine spolecnosti holdingu (podminkou Kooperace_cenik.kooporg!="0" si zajistuji nevyrazeni operaci v externi kooperaci mimo spolecnosti holdingu - na ne je totiz specialni stredisko a muze byt dobre, kdyz ve vysledku bude)
   if(!defined($normativkoop)) {
      my $sth_koop=$dbh->prepare(q{
         select
            Kooperace_cenik.odoper,
            Kooperace_cenik.dooper
         from
            Vyroba_priprava.Kooperace_cenik
         where
            Kooperace_cenik.org=? and
            Kooperace_cenik.zak like ? and
            Kooperace_cenik.platod<=? and
            Kooperace_cenik.platdo>=? and
            Kooperace_cenik.kmorg=? and
            Kooperace_cenik.kooporg!="0"
         order by
            Kooperace_cenik.odoper asc
      });
      $sth_koop->execute(get_env("org"),substr($zak,0,13).'%',get_env("datum"),get_env("datum"),get_env("org"));
      my @oper;
      if($sth_koop->rows>0) {
         @oper=sort keys(%{$KAPmin1ksoper});
      }
      while(my $ref_koop=$sth_koop->fetchrow_hashref) {
         while(my $oper=shift(@oper)) {
            # likvidace udaju o operacich, ktere jsou v kooperaci
            if($oper ge $$ref_koop{odoper} and $oper le $$ref_koop{dooper}) {
               delete($$KAPmin1ksoper{$oper});
            }
            elsif($oper gt $$ref_koop{dooper}) {
               unshift(@oper,$oper);
               last;
            }
         }
      }
      $sth_koop->finish;
   }
   # Zaverecne zpracovani udaju
   foreach my $oper (keys %{$KAPmin1ksoper}) {
      my $ref=$$KAPmin1ksoper{$oper};
      # !!! Pozor zmena klicu nize si vyzada zmenu i ve fci KAPsouhrn_plan_min1ks_koop !!!
      $$KAPmin1ks{$$ref{str}}{$$ref{prac}}{tAmin}+=$$ref{tamin};
      $$KAPmin1ks{$$ref{str}}{$$ref{prac}}{tVmin}+=$$ref{tvmin};
      $$KAPmin1ks{$$ref{str}}{$$ref{prac}}{tBmin}+=$$ref{tbmin1ks};
   }
   return $KAPmin1ks;
}

#- Funkce pocita tAmin, tVmin a tBmin na jeden kus zak na prislusnem kmint
sub KAPsouhrn_plan_min1ks_koop {
   my ($pkg_p, $zak,$kmint,$kooporg)=@_;
   my $KAPmin1ks;
   my $normativ=Info->normativy($zak,$kmint);
   # Nalezeni pripadnych kooperacnich zakazek na prislusnem kmint
   my $sth_koop=$dbh->prepare(q{
      select
         Kooperace_cenik.zak
      from
         Vyroba_priprava.Kooperace_cenik
      where
         Kooperace_cenik.org=? and
         Kooperace_cenik.zak like ? and
         Kooperace_cenik.platod<=? and
         Kooperace_cenik.platdo>=? and
         Kooperace_cenik.odoper>=? and
         Kooperace_cenik.dooper<=? and
         Kooperace_cenik.kmorg=? and
         Kooperace_cenik.kooporg=?
      order by
         Kooperace_cenik.odoper asc
   });
   $sth_koop->execute(get_env("org"),substr($zak,0,13).'%',get_env("datum"),get_env("datum"),$$normativ{odoper},$$normativ{dooper},get_env("org"),$kooporg);
   # pamatovak momentalnich promennych prostredi (abych je mohl posleze vratit)
   my $Eorg=get_env("org");
   # nastaveni nove promenne prostredi
   set_env("org",$kooporg);
   while(my $ref_koop=$sth_koop->fetchrow_hashref) {
      my $KAPmin1ksprac=$pkg->KAPsouhrn_plan_min1ks($$ref_koop{zak},$kmint,$normativ);
      foreach my $str (%{$KAPmin1ksprac}) {
         foreach my $prac (%{$$KAPmin1ksprac{$str}}) {
            $$KAPmin1ks{$str}{$prac}{tAmin}+=$$KAPmin1ksprac{$str}{$prac}{tAmin};
            $$KAPmin1ks{$str}{$prac}{tVmin}+=$$KAPmin1ksprac{$str}{$prac}{tVmin};
            $$KAPmin1ks{$str}{$prac}{tBmin}+=$$KAPmin1ksprac{$str}{$prac}{tBmin};
         }
      }
   }
   $sth_koop->finish;
   # vraceni promennych prostredi do puvodniho stavu
   set_env("org",$Eorg);
   return $KAPmin1ks;
}


#-- Rozpis --

#- Vypocet kolik je treba casu a stroju (respektive lidi) (klic: prac,(koop)zak,oper,obdobi,"")
sub KAProzpis_plan {
   my ($pkg_p, $polozky)=@_;
   my $KAPmin;
   # vypocet kolik je treba vyrobit kusu dle planu (klic: zak,kmint,obdobi)
   my $KAPks=$pkg->kapks_plan($polozky);
   # pamatovak momentalnich promennych prostredi (abych je mohl posleze vratit)
   my $Eorg=get_env("org");
   my $Edatum=get_env("datum");
   foreach my $zak (keys %{$KAPks}) {
      foreach my $kmint (keys %{$$KAPks{$zak}}) {
         foreach my $obdobi (keys %{$$KAPks{$zak}{$kmint}}) {
            # nastaveni promennych prostredi pro ucely moznosti uzit fci zjistujici normativy a dalsi udaje v normach i jinde
            set_env("org",$$KAPks{$zak}{$kmint}{$obdobi}{org});
            # poznamka - doplnujici udaje budu ziskavat na datum platnosti zjisteneho terminu (pokud jde vsak o minulost tak na aktualni datum)
            if($$KAPks{$zak}{$kmint}{$obdobi}{normplat} ge My->date_now) {
               set_env("datum",$$KAPks{$zak}{$kmint}{$obdobi}{normplat});
            }
            else {
               set_env("datum", My->date_now);
            }
            # zjisteni informaci o fondu pracovni doby - u org pro kterou pocitam kapacity
            my $kapfond=Info->kapfond($Eorg,$$polozky{vpdruhobd}{value});
            # vypocet casu na jeden ks
            my $KAPmin1ks;
            if($Eorg eq get_env("org")) {
               $KAPmin1ks=$pkg->KAProzpis_plan_min1ks($zak,$kmint,undef, $$polozky{str}{value},$$polozky{prac}{value});
            }
            else {
               $KAPmin1ks=$pkg->KAProzpis_plan_min1ks_koop($zak,$kmint,$Eorg, $$polozky{str}{value},$$polozky{prac}{value});
            }
            foreach my $koopzak (%{$KAPmin1ks}) { # pokud byl vyledek ziskan z fce KAPmin1ks_koop muze byt vraceno i vice koopzak, jinak je vracena vzdy jen jedna
               foreach my $prac (%{$$KAPmin1ks{$koopzak}}) {
                  my $skupprac;
                  if(!$$polozky{skupprac}{value}) {
                     $skupprac=$prac;
                  }
                  else {
                     my $info_prac=Info->prac($$polozky{str}{value},$prac);
                     $skupprac=$$info_prac{skup};
                  }
                  foreach my $oper (%{$$KAPmin1ks{$koopzak}{$prac}}) {
                     if($$KAPmin1ks{$koopzak}{$prac}{$oper}{tAmin}>0 or $$KAPmin1ks{$koopzak}{$prac}{$oper}{tVmin}>0 or $$KAPmin1ks{$koopzak}{$prac}{$oper}{tBmin}>0) {
                        if($$polozky{rezim}{value} eq "0") {
                           my $info_kapprac=Info->kapprac($$polozky{str}{value},$prac);
                           foreach my $tXmin ("tVmin","tBmin") {
                              my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$koopzak}{$prac}{$oper}{$tXmin}/60;
                              $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                              if($kapfond!=0) {
                                 $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond/$$info_kapprac{smeny};
                              }
                           }
                        }
                        elsif($$polozky{rezim}{value} eq "1") {
                           foreach my $tXmin ("tVmin","tBmin") {
                              my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$koopzak}{$prac}{$oper}{$tXmin}/60;
                              $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                              if($kapfond!=0) {
                                 $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond;
                              }
                           }
                        }
                        elsif($$polozky{rezim}{value} eq "2") {
                           my $info_kapprac=Info->kapprac($$polozky{str}{value},$prac);
                           foreach my $tXmin ("tAmin","tBmin") {
                              my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$koopzak}{$prac}{$oper}{$tXmin}/60/$$info_kapprac{vykon};
                              $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                              if($kapfond!=0) {
                                 $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond;
                              }
                           }
                        }
                        elsif($$polozky{rezim}{value} eq "3") {
                           foreach my $tXmin ("tAmin","tBmin") {
                              my $T=$$KAPks{$zak}{$kmint}{$obdobi}{ks}*$$KAPmin1ks{$koopzak}{$prac}{$oper}{$tXmin}/60;
                              $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{T}+=$T;
                              if($kapfond!=0) {
                                 $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{$T2dm{$tXmin}}{LS}+=$T/$kapfond;
                              }
                           }
                        }
                        $$KAPmin{$skupprac}{$koopzak}{$oper}{$obdobi}{""}{Ks}+=$$KAPks{$zak}{$kmint}{$obdobi}{ks};
                     }
                  }
               }
            }
         }
      }
   }
   # vraceni promennych prostredi do puvodniho stavu
   set_env("org",$Eorg);
   set_env("datum",$Edatum);
   return $KAPmin;
}

#- Funkce pocita tAmin, tVmin a tBmin na jeden kus zak na prislusnem kmint
sub KAProzpis_plan_min1ks {
   my ($pkg_p, $zak,$kmint,$normativkoop, $str,$prac)=@_;
   my $KAPmin1ks;
   my $normativ;
   if(!defined($normativkoop)) {
      $normativ=Info->normativy($zak,$kmint);
   }
   else {
      $normativ=$normativkoop;
   }
   # Napocitani udaju z vykonove normy
   my ($dotaz,@dotazparam);
   $dotaz.=q{
      select
         Vykon_norma.oper,
         Vykon_norma.prac,
         Vykon_norma.tamin,
         Vykon_norma.tbmin/Vykon_norma.davka as tbmin1ks,
         Vykon_norma.tvmin
      from
         Vyroba_priprava.Vykon_norma
      where
         Vykon_norma.org=? and
         Vykon_norma.zak=? and
         Vykon_norma.oper>=? and
         Vykon_norma.oper<=? and
         Vykon_norma.platod<=? and
         Vykon_norma.platdo>=? and
         Vykon_norma.str=? and
         Vykon_norma.ind!="5"
   };
   push(@dotazparam,(get_env("org"),$zak,$$normativ{odoper},$$normativ{dooper},get_env("datum"),get_env("datum"),$str));
   if(length($prac)) {
      $dotaz.=q{
         and
         Vykon_norma.prac=?
      };
      push(@dotazparam,$prac);
   }
   $dotaz.=q{
      order by
         Vykon_norma.oper asc
   };
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazparam);
   my $KAPmin1ksoper;
   while(my $ref=$sth->fetchrow_hashref) {
      $$KAPmin1ksoper{$$ref{oper}}=$ref;
   }
   $sth->finish;
   # Vyrazeni operaci, ktere se delaji v kooperaci na jine spolecnosti holdingu (podminkou Kooperace_cenik.kooporg!="0" si zajistuji nevyrazeni operaci v externi kooperaci mimo spolecnosti holdingu - na ne je totiz specialni stredisko a muze byt dobre, kdyz ve vysledku bude)
   if(!defined($normativkoop)) {
      my $sth_koop=$dbh->prepare(q{
         select
            Kooperace_cenik.odoper,
            Kooperace_cenik.dooper
         from
            Vyroba_priprava.Kooperace_cenik
         where
            Kooperace_cenik.org=? and
            Kooperace_cenik.zak like ? and
            Kooperace_cenik.platod<=? and
            Kooperace_cenik.platdo>=? and
            Kooperace_cenik.kmorg=? and
            Kooperace_cenik.kooporg!="0"
         order by
            Kooperace_cenik.odoper asc
      });
      $sth_koop->execute(get_env("org"),substr($zak,0,13).'%',get_env("datum"),get_env("datum"),get_env("org"));
      my @oper;
      if($sth_koop->rows>0) {
         @oper=sort keys(%{$KAPmin1ksoper});
      }
      while(my $ref_koop=$sth_koop->fetchrow_hashref) {
         while(my $oper=shift(@oper)) {
            # likvidace udaju o operacich, ktere jsou v kooperaci
            if($oper ge $$ref_koop{odoper} and $oper le $$ref_koop{dooper}) {
               delete($$KAPmin1ksoper{$oper});
            }
            elsif($oper gt $$ref_koop{dooper}) {
               unshift(@oper,$oper);
               last;
            }
         }
      }
      $sth_koop->finish;
   }
   # Zaverecne zpracovani udaju
   foreach my $oper (keys %{$KAPmin1ksoper}) {
      my $ref=$$KAPmin1ksoper{$oper};
      # !!! Pozor zmena klicu nize si vyzada zmenu i ve fci KAProzpis_plan_min1ks_koop !!!
      $$KAPmin1ks{$zak}{$$ref{prac}}{$$ref{oper}}{tAmin}+=$$ref{tamin};
      $$KAPmin1ks{$zak}{$$ref{prac}}{$$ref{oper}}{tVmin}+=$$ref{tvmin};
      $$KAPmin1ks{$zak}{$$ref{prac}}{$$ref{oper}}{tBmin}+=$$ref{tbmin1ks};
   }
   return $KAPmin1ks;
}

#- Funkce pocita tAmin, tVmin a tBmin na jeden kus zak na prislusnem kmint
sub KAProzpis_plan_min1ks_koop {
   my ($pkg_p, $zak,$kmint,$kooporg, $str,$prac)=@_;
   my $KAPmin1ks;
   my $normativ=Info->normativy($zak,$kmint);
   # Nalezeni pripadnych kooperacnich zakazek na prislusnem kmint
   my $sth_koop=$dbh->prepare(q{
      select
         Kooperace_cenik.zak
      from
         Vyroba_priprava.Kooperace_cenik
      where
         Kooperace_cenik.org=? and
         Kooperace_cenik.zak like ? and
         Kooperace_cenik.platod<=? and
         Kooperace_cenik.platdo>=? and
         Kooperace_cenik.odoper>=? and
         Kooperace_cenik.dooper<=? and
         Kooperace_cenik.kmorg=? and
         Kooperace_cenik.kooporg=?
      order by
         Kooperace_cenik.odoper asc
   });
   $sth_koop->execute(get_env("org"),substr($zak,0,13).'%',get_env("datum"),get_env("datum"),$$normativ{odoper},$$normativ{dooper},get_env("org"),$kooporg);
   # pamatovak momentalnich promennych prostredi (abych je mohl posleze vratit)
   my $Eorg=get_env("org");
   # nastaveni nove promenne prostredi
   set_env("org",$kooporg);
   while(my $ref_koop=$sth_koop->fetchrow_hashref) {
      my $KAPmin1ksprac=$pkg->KAProzpis_plan_min1ks($$ref_koop{zak},$kmint,$normativ, $str,$prac);
      foreach my $koopzak (%{$KAPmin1ksprac}) { # vraci vzdy jen jednu koopzak
         foreach my $prac (%{$$KAPmin1ksprac{$koopzak}}) {
            foreach my $oper (%{$$KAPmin1ksprac{$koopzak}{$prac}}) {
               $$KAPmin1ks{$koopzak}{$prac}{$oper}{tAmin}+=$$KAPmin1ksprac{$koopzak}{$prac}{$oper}{tAmin};
               $$KAPmin1ks{$koopzak}{$prac}{$oper}{tVmin}+=$$KAPmin1ksprac{$koopzak}{$prac}{$oper}{tVmin};
               $$KAPmin1ks{$koopzak}{$prac}{$oper}{tBmin}+=$$KAPmin1ksprac{$koopzak}{$prac}{$oper}{tBmin};
            }
         }
      }
   }
   $sth_koop->finish;
   # vraceni promennych prostredi do puvodniho stavu
   set_env("org",$Eorg);
   return $KAPmin1ks;
}



#========= Cast Plan 2 ==================================================#

#- Vypocet kolik je treba vyrobit kusu dle planu (klic: zak,kmint,obdobi)
sub kapks_plan {
   my ($pkg_p, $polozky)=@_;
   my $KAPks;
   #-
   my @obdobi=$pkg->obdobi($polozky);
   my ($datummin,$datummax)=$pkg->datumminmax($polozky);
   #- Priprava dotazu
   my ($dotaz,@dotazpara);
   # select
   $dotaz.=q{
      select
         Potrebazak.org,
         Potrebazak.zak,
         Potrebazak.kmint,
   };
   if($$polozky{vpdruhobd}{value} eq "m") {
      $dotaz.=q{
            if(
               Potrebazak.termin<=?,?,
               substring(Potrebazak.termin,1,7)
            ) as obdobi,
      };
      push(@dotazpara, $datummin,$obdobi[0]);
   }
   elsif($$polozky{vpdruhobd}{value} eq "d") {
      $dotaz.=q{
            if(
               Potrebazak.termin<=?,?,
               concat(substring(Potrebazak.termin,1,8),
                  if(
                     substring(Potrebazak.termin,9,2)<11,"01",
                        if(
                           substring(Potrebazak.termin,9,2)<21,"11",
                           "21"
                        )
                  )
               )
            ) as obdobi,
      };
      push(@dotazpara, $datummin,$obdobi[0]);
   }
   elsif($$polozky{vpdruhobd}{value} eq "q") {
      $dotaz.=q{
            if(
               Potrebazak.termin<=?,?,
               concat(year(Potrebazak.termin),"-",quarter(Potrebazak.termin),"Q")
            ) as obdobi,
      };
      push(@dotazpara, $datummin,$obdobi[0]);
   }
   $dotaz.=q{
            min(Potrebazak.termin) as normplat,
   };
   if($$polozky{davkovane}{value}) {
      $dotaz.=q{
            sum(Potrebazak.plan+Potrebazak.planbudouci) as odvestV
      };
   }
   else {
      $dotaz.=q{
            sum(Potrebazak.chybi) as odvestV
      };
   }
   # from
   $dotaz.=q{
      from
         Vyroba_planovani.Potrebazak
   };
   # where
   if(!$$polozky{zobkoop}{value}) {
      $dotaz.=q{
         where
            Potrebazak.org=?
      };
      push(@dotazpara,get_env("org"));
   }
   else {
      $dotaz.=q{
         where
            1
      };
   }
   # where - vse az na matros a horove casti, ktere jiste nemaji vykonovou normu
   $dotaz.=q{
      and
      Potrebazak.kmint>?
      and
      Potrebazak.kmint<?
   };
   push(@dotazpara,"000","999");
   # where - jeste je treba vyfiltrovat sklad rv (aby kmenove intervaly pred kterymi lezi zak na rv tam nebyly dvakrat)
   my @str_rv=Spolecnost->seznam_str("sklrv");
   if(defined($str_rv[0])) {
      $dotaz.=q{
         and
         Potrebazak.str!=?
      };
      push(@dotazpara,$str_rv[0]);
   }
   # where neni treba az do nekonecna... udelej omezeni
   $dotaz.=q{
         and
         Potrebazak.termin<?
   };
   push(@dotazpara,$datummax);
   # where - sortiment
   if(length($$polozky{sor}{value})) {
      $dotaz.=q{
            and
            Potrebazak.sor like ?
      };
      push(@dotazpara,$$polozky{sor}{value}."%");
   }
   # group by - musi korespondovat s fci key nize!!!
   $dotaz.=q{
      group by
         Potrebazak.org,
         Potrebazak.zak,
         Potrebazak.kmint,
         obdobi
   };
   # having - chybi>0
   $dotaz.=q{
      having
         odvestV>0
   };
   # order by
   $dotaz.=q{
      order by
         Potrebazak.org asc,
         Potrebazak.zak asc,
         Potrebazak.kmint asc,
         obdobi asc
   };
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   while(my $ref=$sth->fetchrow_hashref) {
      $$KAPks{$$ref{zak}}{$$ref{kmint}}{$$ref{obdobi}}{org}=$$ref{org};
      $$KAPks{$$ref{zak}}{$$ref{kmint}}{$$ref{obdobi}}{normplat}=$$ref{normplat};
      $$KAPks{$$ref{zak}}{$$ref{kmint}}{$$ref{obdobi}}{ks}=$$ref{odvestV};
   }
   $sth->finish;
   return $KAPks
}


#=== Pomocne fce Cast Plan 2 uzce souvisejici se setavenim dotazu

#- stanoveni seznamu obdobi, pres ktere pojedu
sub obdobi {
   my ($pkg_p, $polozky)=@_;
   my @obdobi;
   # stanoveni obdobi, pres ktere pojedu a ktere budu zobrazovat
   if($$polozky{vpdruhobd}{value} eq "m") {
      foreach my $i (0..($$polozky{pocetobd}{value}-1)) {
         push(@obdobi,My->period_addmonth($$polozky{vychdatum}{value},$i));
      }
   }
   elsif($$polozky{vpdruhobd}{value} eq "d") {
      foreach my $i (0..($$polozky{pocetobd}{value}-1)) {
         push(@obdobi,My->date_adddecade($$polozky{vychdatum}{value},$i));
      }
   }
   elsif($$polozky{vpdruhobd}{value} eq "q") {
      foreach my $i (0..($$polozky{pocetobd}{value}-1)) {
         my $periodmonth=My->period_addmonth($$polozky{vychdatum}{value},3*$i);
         my ($year,$month)=split(/-/,$periodmonth);
         $month*=1;
         my $quarter;
         if($month<4) {
            $quarter=1;
         }
         elsif($month<7) {
            $quarter=2;
         }
         elsif($month<10) {
            $quarter=3;
         }
         else {
            $quarter=4;
         }
         push(@obdobi, $year . "-" . $quarter . "Q");
      }
   }
   return (@obdobi);
}

#- urceni maximalniho a minimalniho data, ktere mne zajima (pomoci nich pak zuzuji vyber pri dotazu na predpocteny plan (tabulku Potrebazak) a tim zuzuji poctet potrebnych zaznamu a zrychluji vypocet)
sub datumminmax {
   my ($pkg_p, $polozky)=@_;
   my $datummin= substr($$polozky{vychdatum}{value},0,7) . "-01";
   my $datummax;
   if($$polozky{vpdruhobd}{value} eq "m") {
      $datummax=My->period_addmonth($$polozky{vychdatum}{value},$$polozky{pocetobd}{value})."-01";
   }
   elsif($$polozky{vpdruhobd}{value} eq "d") {
      $datummax=My->date_adddecade($$polozky{vychdatum}{value},$$polozky{pocetobd}{value});
   }
   elsif($$polozky{vpdruhobd}{value} eq "q") {
      $datummax=My->period_addmonth($$polozky{vychdatum}{value},3*$$polozky{pocetobd}{value})."-01";
   }
   return ($datummin,$datummax);
}



#========= Cast Skutecnost 1 ==================================================#

#-- Souhrn --

#- Vypocet kolik bylo treba casu a stroju (respektive lidi) (klic: str,prac,obdobi,zndm)
sub KAPsouhrn_skut {
   my ($pkg_p, $polozky)=@_;
   my $KAPmin;
   # pamatovak momentalnich promennych prostredi (abych je mohl posleze vratit)
   my $Eorg=get_env("org");
   my $Edatum=get_env("datum");
   #- Priprava dotazu
   my ($dotaz,@dotazpara)=$pkg->dotaz_skut($polozky,"souhrn");
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   while(my $ref=$sth->fetchrow_hashref) {
      # nastaveni promennych prostredi pro ucely moznosti uzit fci zjistujici kapacitni koeficienty (sou tam data platnosti)
      # u skutecnosti vzdy pracujes s datem skutecnosti i kdyz je v minulosti
      set_env("datum",$$ref{normplat});
      # zjisteni informaci o fondu pracovni doby - u org pro kterou pocitam kapacity
      my $kapfond=Info->kapfond($Eorg,$$polozky{vpdruhobd}{value});
      # pripadna konverze pracoviste na skupinu pracovist
      my $skupprac;
      if(!$$polozky{skupprac}{value}) {
         $skupprac=$$ref{prac};
      }
      else {
         my $info_prac=Info->prac($$ref{str},$$ref{prac});
         $skupprac=$$info_prac{skup};
      }
      if($$polozky{rezim}{value} eq "0") {
         my $info_kapprac=Info->kapprac($$ref{str},$$ref{prac});
         my $T=($$ref{tAV}+$$ref{tB});
         $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond/$$info_kapprac{smeny};
         }
      }
      elsif($$polozky{rezim}{value} eq "1") {
         my $T=($$ref{tAV}+$$ref{tB});
         $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond;
         }
      }
      elsif($$polozky{rezim}{value} eq "2") {
         my $info_kapprac=Info->kapprac($$ref{str},$$ref{prac});
         my $T=($$ref{tAV}+$$ref{tB})/$$info_kapprac{vykon};
         $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond;
         }
      }
      elsif($$polozky{rezim}{value} eq "3") {
         my $T=($$ref{tAV}+$$ref{tB});
         $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$$ref{str}}{$skupprac}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond;
         }
      }
   }
   $sth->finish;
   # vraceni promennych prostredi do puvodniho stavu
   set_env("org",$Eorg);
   set_env("datum",$Edatum);
   return $KAPmin;
}


#-- Rozpis --

#- Vypocet kolik je treba casu a stroju (respektive lidi) (klic: prac,(koop)zak,oper,obdobi,zndm)
sub KAProzpis_skut {
   my ($pkg_p, $polozky)=@_;
   my $KAPmin;
   # pamatovak momentalnich promennych prostredi (abych je mohl posleze vratit)
   my $Eorg=get_env("org");
   my $Edatum=get_env("datum");
   #- Priprava dotazu
   my ($dotaz,@dotazpara)=$pkg->dotaz_skut($polozky,"rozpis");
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   while(my $ref=$sth->fetchrow_hashref) {
      # nastaveni promennych prostredi pro ucely moznosti uzit fci zjistujici kapacitni koeficienty (sou tam data platnosti)
      # u skutecnosti vzdy pracujes s datem skutecnosti i kdyz je v minulosti
      set_env("datum",$$ref{normplat});
      # zjisteni informaci o fondu pracovni doby - u org pro kterou pocitam kapacity
      my $kapfond=Info->kapfond($Eorg,$$polozky{vpdruhobd}{value});
      # pripadna konverze pracoviste na skupinu pracovist
      my $skupprac;
      if(!$$polozky{skupprac}{value}) {
         $skupprac=$$ref{prac};
      }
      else {
         my $info_prac=Info->prac($$ref{str},$$ref{prac});
         $skupprac=$$info_prac{skup};
      }
      if($$polozky{rezim}{value} eq "0") {
         my $info_kapprac=Info->kapprac($$ref{str},$$ref{prac});
         my $T=($$ref{tAV}+$$ref{tB});
         $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond/$$info_kapprac{smeny};
         }
      }
      elsif($$polozky{rezim}{value} eq "1") {
         my $T=($$ref{tAV}+$$ref{tB});
         $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond;
         }
      }
      elsif($$polozky{rezim}{value} eq "2") {
         my $info_kapprac=Info->kapprac($$ref{str},$$ref{prac});
         my $T=($$ref{tAV}+$$ref{tB})/$$info_kapprac{vykon};
         $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond;
         }
      }
      elsif($$polozky{rezim}{value} eq "3") {
         my $T=($$ref{tAV}+$$ref{tB});
         $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{T}+=$T;
         if($kapfond!=0) {
            $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{LS}+=$T/$kapfond;
         }
      }
      $$KAPmin{$skupprac}{$$ref{zak}}{$$ref{oper}}{$$ref{obdobi}}{$$ref{zndm}}{Ks}+=$$ref{ks};
   }
   $sth->finish;
   # vraceni promennych prostredi do puvodniho stavu
   set_env("org",$Eorg);
   set_env("datum",$Edatum);
   return $KAPmin;
}



#========= Cast Skutecnost 2 ==================================================#


#=== Pomocne fce Cast Plan 2 uzce souvisejici se setavenim dotazu

#- fce vraci pripraveny dotaz pro skutecnost
sub dotaz_skut {
   my ($pkg_p, $polozky,$co)=@_;
   #-
   my @obdobi=$pkg->obdobi($polozky);
   my ($datummin,$datummax)=$pkg->datumminmax($polozky);
   #- Priprava dotazu
   my ($dotaz,@dotazpara);
   # select
   if($co eq "rozpis") {
      # !!! NEDOSTATEK - v souboru Odpracvyk, neni zaznamenana casova zpotreba v praci na zmneplac (proto je ani nezapocitavam mezi kusy, ale jde o nedostatek, jelikoz cas na nych stroj (koneckoncu i delnik) musel zpotrebovat...)
      $dotaz.=q{
         select
            Odpracvyk.str,
            Odpracvyk.prac,
            Odpracvyk.zak,
            Odpracvyk.oper,
            if(Odpracvyk.dm!=12,Odpracvyk.dm,"11") as zndm,
      };
   }
   else {
      $dotaz.=q{
         select
            Odpracvyk.str,
            Odpracvyk.prac,
            if(Odpracvyk.dm!=12,Odpracvyk.dm,"11") as zndm,
      };
   }
   # obdobi
   if($$polozky{vpdruhobd}{value} eq "m") {
      $dotaz.=q{
            Odpracvyk.ucetobd as obdobi,
      };
   }
   elsif($$polozky{vpdruhobd}{value} eq "d") {
      die "Skutecnost neni mozne zatim mit v dekadach.";
   }
   elsif($$polozky{vpdruhobd}{value} eq "q") {
      $dotaz.=q{
            concat(substring(Odpracvyk.ucetobd,1,4),"-",quarter(concat(Odpracvyk.ucetobd,"-01")),"Q") as obdobi,
      };
   }
   # pro nastavovani dataplatnosti pri pruchodu vysledku dotazu a nasladnym odskakovanim pro zjistovani doplnujicich udaju z norem a kapacitnich koeficientu
   $dotaz.=q{
         concat(Odpracvyk.ucetobd,"-01") as normplat,
   };
   # ks
   if($co eq "rozpis") {
      $dotaz.=q{
            sum(Odpracvyk.ksdobr+Odpracvyk.zmplac) as ks,
      };
   }
   # casy
   if($$polozky{rezim}{value} eq "0" or $$polozky{rezim}{value} eq "1") { # ziskavam koeficient prepoctu tA na tV z vykonove normy
      $dotaz.=q{
            sum( if(Odpracvyk.dm!=15,Odpracvyk.nhod,0) * if( (Vykon_norma.tvmin/Vykon_norma.tamin) not in(0,NULL), Vykon_norma.tvmin/Vykon_norma.tamin, 1 ) ) as tAV,
      };
   }
   else {
      $dotaz.=q{
            sum( if(Odpracvyk.dm!=15,Odpracvyk.nhod,0) ) as tAV,
      };
   }
   $dotaz.=q{
         sum( if(Odpracvyk.dm=15,Odpracvyk.nhod,0) ) as tB
   };
   # from
   $dotaz.=q{
      from
         Vyroba_evidence.Odpracvyk
   };
   if($$polozky{rezim}{value} eq "0" or $$polozky{rezim}{value} eq "1") {
      $dotaz.=q{
            left join Vyroba_priprava.Vykon_norma on (Odpracvyk.org=Vykon_norma.org and Odpracvyk.zak=Vykon_norma.zak and Odpracvyk.oper=Vykon_norma.oper and Vykon_norma.platod<=concat(Odpracvyk.ucetobd,"-01") and Vykon_norma.platdo>=concat(Odpracvyk.ucetobd,"-01"))
      };
   }
   # where
   $dotaz.=q{
      where
         Odpracvyk.org=?
   };
   push(@dotazpara,get_env("org"));
   # where neni treba od nekonecna do nekonecna... udelej omezeni
   $dotaz.=q{
         and
         Odpracvyk.ucetobd>=?
         and
         Odpracvyk.ucetobd<?
   };
   push(@dotazpara,substr($datummin,0,7),substr($datummax,0,7));
   # where - DM - asi nechci vsechny druhy mezd??
   if($$polozky{typdm}{value} eq "0") {
      $dotaz.=q{
            and
            Odpracvyk.dm in("11","12","15")
      };
   }
   elsif($$polozky{typdm}{value} eq "1") {
      $dotaz.=q{
            and
            Odpracvyk.dm in("11","12","14","15")
      };
   }
   elsif($$polozky{typdm}{value} eq "2") {
      $dotaz.=q{
            and
            Odpracvyk.dm in("11","12","13","14","15")
      };
   }
   elsif($$polozky{typdm}{value} eq "3") {
      $dotaz.=q{
            and
            Odpracvyk.dm in("11","12")
      };
   }
   elsif($$polozky{typdm}{value} eq "4") {
      $dotaz.=q{
            and
            Odpracvyk.dm in("15")
      };
   }
   # where - sortiment
   if(length($$polozky{sor}{value})) {
      die "Skutecnost neumis omezit na sortiment.";
   }
   # where - str - ma smysl jen u "rozpis"
   if(length($$polozky{str}{value})) {
      $dotaz.=q{
            and
            Odpracvyk.str=?
      };
      push(@dotazpara,$$polozky{str}{value});
   }
   # where - prac - ma smysl jen u "rozpis"
   if(length($$polozky{prac}{value})) {
      $dotaz.=q{
            and
            Odpracvyk.prac=?
      };
      push(@dotazpara,$$polozky{prac}{value});
   }
   if($co eq "rozpis") {
      # group by - musi korespondovat s fci key nize!!!
      $dotaz.=q{
         group by
            Odpracvyk.str,
            Odpracvyk.prac,
            Odpracvyk.zak,
            Odpracvyk.oper,
            obdobi,
            zndm
      };
      # having - T!=0
      $dotaz.=q{
         having
            tAV!=0
            or
            tB!=0
      };
      # order by
      $dotaz.=q{
         order by
            Odpracvyk.str,
            Odpracvyk.prac,
            Odpracvyk.zak,
            Odpracvyk.oper,
            obdobi,
            zndm
      };
   }
   else {
      # group by - musi korespondovat s fci key nize!!!
      $dotaz.=q{
         group by
            Odpracvyk.str,
            Odpracvyk.prac,
            obdobi,
            zndm
      };
      # having - T!=0
      $dotaz.=q{
         having
            tAV!=0
            or
            tB!=0
      };
      # order by
      $dotaz.=q{
         order by
            Odpracvyk.str,
            Odpracvyk.prac,
            obdobi,
            zndm
      };
   }
   return ($dotaz,@dotazpara);
}



return 1;

